#ifndef __CURSES_INPUT_H__
#define __CURSES_INPUT_H__

#include <memory>
#include "input.h"
#include "constants.h"
#include "cursor.h"

class curses_input final: public input {
private:
        const std::unique_ptr<cursor> &curse;
public:
        curses_input(const std::unique_ptr<cursor> &new_curse);
        game_command get_command() override;
};

#endif
